Attribute VB_Name = "Module1"
Global Const LISTVIEW_MODE0 = "View Large Icons"
Global Const LISTVIEW_MODE1 = "View Small Icons"
Global Const LISTVIEW_MODE2 = "View List"
Global Const LISTVIEW_MODE3 = "View Details"
Public fMainForm As frmMain
Public KomPort As Variant
Public Lista As Integer
Public lon As Single
Public lat As Single
Public sunrise As Variant
Public sunset As Variant
Public opLog As Integer
Public sIkon As Integer
Public DblClickEdit As Integer
Public AutoLog As Integer
Public LogAll As Integer
Public VD As Variant

Public Type Unit
    Id As Integer
    Lokal As String
    Namn As String
    Typ As String
    Kod As String
    Senast As String
    Status As String
    Top As Integer
    Left As Integer
    OnIcon As Integer
    OffIcon As Integer
    Dimbar As Integer
End Type
Public Enhet As Unit

Public EnhetInfo() As String
Public TmpObj(18) As Variant

Private Declare Function SetForegroundWindow Lib "user32" (ByVal hWnd As Long) As Long
'Private Declare Function ShowWindow Lib "user32" (ByVal hWnd As Long, nCmdShow As Long) As Long
Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As Any, ByVal lpWindowName As Any) As Long

Private Function SetFocusByCaption(strCaption As String) As Boolean
    Dim lngHandle As Long
    Dim lngResult As Long
    
    lngHandle = FindWindow(vbNullString, strCaption)
    If lngHandle <> 0 Then
        'ShowWindow lngHandle, 1
        lngResult = SetForegroundWindow(lngHandle)
        If lngResult = 0 Then
            SetFocusByCaption = False
        Else
            SetFocusByCaption = True
        End If
    Else
        SetFocusByCaption = False
    End If
End Function

Sub Main()
On Error GoTo felstart
    
    Dim tTitle As String
    tTitle = App.Title
    App.Title = "PreStart" & tTitle
    If App.PrevInstance = True Then
        MsgBox "Programmet krs redan, gr ej att starta flera fnster.", vbOKOnly + vbExclamation, tTitle
        SetFocusByCaption tTitle
        End
    End If
    App.Title = tTitle
 
    frmSplash.Show
    frmSplash.Refresh
    frmSplash.PBar1.Value = 10
    Set fMainForm = New frmMain
    ChDrive App.Path
    ChDir App.Path
    Load fMainForm
    fMainForm.Show
    Unload frmSplash
    VD = Array("M", "Ti", "On", "To", "Fr", "L", "S")
Exit Sub

felstart:
    MsgBox "Fel vid uppstart: " & err.Description
    Resume Next
End Sub

Public Sub SunCalc()
Dim lo As Integer
Dim azrise As Single    'azimuth of sunrise
Dim j As Single
Dim pd As Single
Dim decl As Single      'declination of sun
Dim equat As Single     'equation of time
Dim tt1 As Single
Dim pi As Single
Dim sunsetm As String
Dim sunrisem As String
Dim dagt As Single
Dim dagm As String
Dim datum As Date
Dim timme As String

    datum = Date
    pi = 3.14159
    j = 180 / pi
    If (lon - 15 * Int(lon / 15)) > 7.5 Then
        lo = (Int(lon / 15) + 1) * 15
    Else
        lo = (Int(lon / 15)) * 15
    End If
    pd = pi * (datum - DateValue(Year(datum) & "-01-01") + 1) / 182.5
    equat = 0.008 + 0.51 * Cos(pd) - 3.197 * Cos(2 * pd) - 0.106 * Cos(3 * pd) - 0.15 * Cos(4 * pd) - 7.317 * Sin(pd) - 9.471 * Sin(2 * pd) - 0.391 * Sin(3 * pd) - 0.242 * Sin(4 * pd)
    decl = 0.456 - 22.915 * Cos(pd) - 0.43 * Cos(2 * pd) - 0.156 * Cos(3 * pd) + 3.83 * Sin(pd) + 0.06 * Sin(2 * pd) - 0.082 * Sin(3 * pd)
    If Abs(Sin(decl / j) / Cos(lat / j)) < 1 Then
        azrise = 90 - j * Atn(Sin(decl / j) / Cos(lat / j) / Sqr(1 - (Sin(decl / j) / Cos(lat / j)) ^ 2))
    Else
        azrise = 0
    End If
    If Abs(Sin(azrise / j) / Cos(decl / j)) >= 1 Then
        tt1 = 6
    Else
        tt1 = j / 15 * Atn(Sin(azrise / j) / Cos(decl / j) / Sqr(1 - (Sin(azrise / j) / Cos(decl / j)) ^ 2))
    End If
    If decl < 0 Then tt1 = 12 - tt1
    If Abs(Sin(decl / j) / Cos(lat / j)) < 1 Then
        sunset = (1 + (-tt1 + (lon - lo) / 15 - equat / 60 + 0.04) / 24) * 24
        sunrise = ((tt1 + (lon - lo) / 15 - equat / 60 - 0.04) / 24) * 24
        If Sommartid Then 'lo = -15 And
            sunset = sunset + 1
            sunrise = sunrise + 1
        End If
    Else
        sunset = 0
        sunrise = 0
    End If
    sunsetm = Int((sunset - Int(sunset)) * 60)
    sunrisem = Int((sunrise - Int(sunrise)) * 60)
    dagt = sunset - sunrise
    dagm = Int((dagt - Int(dagt)) * 60)
    If Int(Val(sunrisem)) < 10 Then sunrisem = "0" & sunrisem
    If Int(Val(sunsetm)) < 10 Then sunsetm = "0" & sunsetm
    If Int(Val(dagm)) < 10 Then dagm = "0" & dagm
    
    If Int(sunrise) < 10 Then timme = "0" & Int(sunrise) Else timme = Int(sunrise)
    sunrise = timme & ":" & sunrisem
    If Int(sunset) < 10 Then timme = "0" & Int(sunset) Else timme = Int(sunset)
    sunset = timme & ":" & sunsetm
End Sub

Function Sommartid() As Boolean
    Const start_manad = 3    'fungerar bara fr rtal efter 1995
    Const stopp_manad = 10
    Sommartid = False
    If ((Month(Date) > start_manad) And (Month(Date) < stopp_manad)) Then
        Sommartid = True
    ElseIf (Month(Date) = start_manad) Then
        If ((31 - Day(Date)) < (8 - Weekday(Date))) Then Sommartid = True
    ElseIf (Month(Date) = stopp_manad) Then
        If Not ((31 - Day(Date)) < (8 - Weekday(Date))) Then Sommartid = True
    End If
End Function
